<template>
  <q-form
    @submit="onSubmit"
    @reset="onReset"
    class="q-gutter-md"
  >
    <q-select
      v-if="holdings.length > 1"
      v-model="holding"
      :options="holdingOptions"
      :label="$gettext('Holding')"
      :rules="[ val => Boolean(val) || $gettext('Select a holding')]"
    />
    <q-input
      v-model="title"
      :placeholder="$gettext('Title')"
      :rules="[ val => val && val.trim().length > 0 || $gettext('Enter a title')]"
    />
    <q-input
      v-model="body"
      outlined
      type="textarea"
      :placeholder="$gettext('Type a message')"
    />
    <div class="row justify-end items-center">
      <q-btn
        :label="$gettext('Reset')"
        type="reset"
        color="primary"
        flat
      />
      <q-btn
        :label="$gettext('Send')"
        color="primary"
        type="submit"
      />
    </div>
  </q-form>
</template>

<script>
import mutationInsertTicket from '../graphql/mutationInsertTicket.gql'

export default {
  name: 'TicketEditForm',
  props: {
    holdings: {
      type: Array,
      required: true
    },
    defaultHolding: {
      type: Object,
      default: null
    }
  },
  data () {
    return {
      title: '',
      body: '',
      holding: this.defaultHolding ? ({ label: this.defaultHolding.name, value: this.defaultHolding.id }) : null
    }
  },
  computed: {
    holdingOptions () {
      return this.holdings.map(({ id, name }) => ({ label: name, value: id }))
    }
  },
  methods: {
    async onSubmit () {
      const data = await this.$apollo.mutate({
        mutation: mutationInsertTicket,
        variables: {
          title: this.title,
          body: this.body,
          holding_id: this.holding.value
        }
      })
      const ticket = data?.data?.insertedTicket
      if (ticket) {
        this.$router.push({ name: 'message', params: { messageType: 'ticket', messageId: ticket.id } })
      }
    },
    onReset () {
      this.title = ''
      this.body = ''
      this.holding = this.defaultHolding ? ({ label: this.defaultHolding.name, value: this.defaultHolding.id }) : null
    }
  }
}
</script>
